BOOT:
  {
#if defined(dTHX) && !defined(PERL_NO_GET_CONTEXT)
    dTHX;
#endif
    HV *symbol_table = get_hv("Linux::Fanotify::", GV_ADD);

    static const struct iv_s values_for_iv[] =
      {
#ifdef FAN_ACCESS
        { "FAN_ACCESS", 10, FAN_ACCESS },
#endif
#ifdef FAN_MODIFY
        { "FAN_MODIFY", 10, FAN_MODIFY },
#endif
#ifdef FAN_CLOSE_WRITE
        { "FAN_CLOSE_WRITE", 15, FAN_CLOSE_WRITE },
#endif
#ifdef FAN_CLOSE_NOWRITE
        { "FAN_CLOSE_NOWRITE", 17, FAN_CLOSE_NOWRITE },
#endif
#ifdef FAN_OPEN
        { "FAN_OPEN", 8, FAN_OPEN },
#endif
#ifdef FAN_Q_OVERFLOW
        { "FAN_Q_OVERFLOW", 14, FAN_Q_OVERFLOW },
#endif
#ifdef FAN_OPEN_PERM
        { "FAN_OPEN_PERM", 13, FAN_OPEN_PERM },
#endif
#ifdef FAN_ACCESS_PERM
        { "FAN_ACCESS_PERM", 15, FAN_ACCESS_PERM },
#endif
#ifdef FAN_ONDIR
        { "FAN_ONDIR", 9, FAN_ONDIR },
#endif
#ifdef FAN_EVENT_ON_CHILD
        { "FAN_EVENT_ON_CHILD", 18, FAN_EVENT_ON_CHILD },
#endif
#ifdef FAN_CLOSE
        { "FAN_CLOSE", 9, FAN_CLOSE },
#endif
#ifdef FAN_CLOEXEC
        { "FAN_CLOEXEC", 11, FAN_CLOEXEC },
#endif
#ifdef FAN_NONBLOCK
        { "FAN_NONBLOCK", 12, FAN_NONBLOCK },
#endif
#ifdef FAN_CLASS_NOTIF
        { "FAN_CLASS_NOTIF", 15, FAN_CLASS_NOTIF },
#endif
#ifdef FAN_CLASS_CONTENT
        { "FAN_CLASS_CONTENT", 17, FAN_CLASS_CONTENT },
#endif
#ifdef FAN_CLASS_PRE_CONTENT
        { "FAN_CLASS_PRE_CONTENT", 21, FAN_CLASS_PRE_CONTENT },
#endif
#ifdef FAN_ALL_CLASS_BITS
        { "FAN_ALL_CLASS_BITS", 18, FAN_ALL_CLASS_BITS },
#endif
#ifdef FAN_UNLIMITED_QUEUE
        { "FAN_UNLIMITED_QUEUE", 19, FAN_UNLIMITED_QUEUE },
#endif
#ifdef FAN_UNLIMITED_MARKS
        { "FAN_UNLIMITED_MARKS", 19, FAN_UNLIMITED_MARKS },
#endif
#ifdef FAN_ALL_INIT_FLAGS
        { "FAN_ALL_INIT_FLAGS", 18, FAN_ALL_INIT_FLAGS },
#endif
#ifdef FAN_MARK_ADD
        { "FAN_MARK_ADD", 12, FAN_MARK_ADD },
#endif
#ifdef FAN_MARK_REMOVE
        { "FAN_MARK_REMOVE", 15, FAN_MARK_REMOVE },
#endif
#ifdef FAN_MARK_DONT_FOLLOW
        { "FAN_MARK_DONT_FOLLOW", 20, FAN_MARK_DONT_FOLLOW },
#endif
#ifdef FAN_MARK_ONLYDIR
        { "FAN_MARK_ONLYDIR", 16, FAN_MARK_ONLYDIR },
#endif
#ifdef FAN_MARK_MOUNT
        { "FAN_MARK_MOUNT", 14, FAN_MARK_MOUNT },
#endif
#ifdef FAN_MARK_IGNORED_MASK
        { "FAN_MARK_IGNORED_MASK", 21, FAN_MARK_IGNORED_MASK },
#endif
#ifdef FAN_MARK_IGNORED_SURV_MODIFY
        { "FAN_MARK_IGNORED_SURV_MODIFY", 28, FAN_MARK_IGNORED_SURV_MODIFY },
#endif
#ifdef FAN_MARK_FLUSH
        { "FAN_MARK_FLUSH", 14, FAN_MARK_FLUSH },
#endif
#ifdef FAN_ALL_MARK_FLAGS
        { "FAN_ALL_MARK_FLAGS", 18, FAN_ALL_MARK_FLAGS },
#endif
#ifdef FAN_ALL_EVENTS
        { "FAN_ALL_EVENTS", 14, FAN_ALL_EVENTS },
#endif
#ifdef FAN_ALL_PERM_EVENTS
        { "FAN_ALL_PERM_EVENTS", 19, FAN_ALL_PERM_EVENTS },
#endif
#ifdef FAN_ALL_OUTGOING_EVENTS
        { "FAN_ALL_OUTGOING_EVENTS", 23, FAN_ALL_OUTGOING_EVENTS },
#endif
#ifdef FANOTIFY_METADATA_VERSION
        { "FANOTIFY_METADATA_VERSION", 25, FANOTIFY_METADATA_VERSION },
#endif
#ifdef FAN_ALLOW
        { "FAN_ALLOW", 9, FAN_ALLOW },
#endif
#ifdef FAN_DENY
        { "FAN_DENY", 8, FAN_DENY },
#endif
#ifdef FAN_NOFD
        { "FAN_NOFD", 8, FAN_NOFD },
#endif
        { NULL, 0, 0 } };
	const struct iv_s *value_for_iv = values_for_iv;
        while (value_for_iv->name) {
	    constant_add_symbol(aTHX_  symbol_table, value_for_iv->name,
				value_for_iv->namelen, newSViv(value_for_iv->value));
            ++value_for_iv;
	}
	if (C_ARRAY_LENGTH(values_for_notfound) > 1) {
#ifndef SYMBIAN
	    HV *const constant_missing = get_missing_hash(aTHX);
#endif
	    const struct notfound_s *value_for_notfound = values_for_notfound;
	    do {

		/* Need to add prototypes, else parsing will vary by platform.  */
		HE *he = (HE*) hv_common_key_len(symbol_table,
						 value_for_notfound->name,
						 value_for_notfound->namelen,
						 HV_FETCH_LVALUE, NULL, 0);
		SV *sv;
#ifndef SYMBIAN
		HEK *hek;
#endif
		if (!he) {
		    croak("Couldn't add key '%s' to %%Linux::Fanotify::",
			  value_for_notfound->name);
		}
		sv = HeVAL(he);
		if (!SvOK(sv) && SvTYPE(sv) != SVt_PVGV) {
		    /* Nothing was here before, so mark a prototype of ""  */
		    sv_setpvn(sv, "", 0);
		} else if (SvPOK(sv) && SvCUR(sv) == 0) {
		    /* There is already a prototype of "" - do nothing  */
		} else {
		    /* Someone has been here before us - have to make a real
		       typeglob.  */
		    /* It turns out to be incredibly hard to deal with all the
		       corner cases of sub foo (); and reporting errors correctly,
		       so lets cheat a bit.  Start with a constant subroutine  */
		    CV *cv = newCONSTSUB(symbol_table,
					 value_for_notfound->name,
					 &PL_sv_yes);
		    /* and then turn it into a non constant declaration only.  */
		    SvREFCNT_dec(CvXSUBANY(cv).any_ptr);
		    CvCONST_off(cv);
		    CvXSUB(cv) = NULL;
		    CvXSUBANY(cv).any_ptr = NULL;
		}
#ifndef SYMBIAN
		hek = HeKEY_hek(he);
		if (!hv_common(constant_missing, NULL, HEK_KEY(hek),
 			       HEK_LEN(hek), HEK_FLAGS(hek), HV_FETCH_ISSTORE,
			       &PL_sv_yes, HEK_HASH(hek)))
		    croak("Couldn't add key '%s' to missing_hash",
			  value_for_notfound->name);
#endif
	    } while ((++value_for_notfound)->name);
	}
    /* As we've been creating subroutines, we better invalidate any cached
       methods  */
    mro_method_changed_in(symbol_table);
  }

void
AUTOLOAD()
    PROTOTYPE: DISABLE
    PREINIT:
	SV *sv = newSVpvn_flags(SvPVX(cv), SvCUR(cv), SVs_TEMP | SvUTF8(cv));
	const COP *cop = PL_curcop;
    PPCODE:
#ifndef SYMBIAN
	/* It's not obvious how to calculate this at C pre-processor time.
	   However, any compiler optimiser worth its salt should be able to
	   remove the dead code, and hopefully the now-obviously-unused static
	   function too.  */
	HV *constant_missing = (C_ARRAY_LENGTH(values_for_notfound) > 1)
	    ? get_missing_hash(aTHX) : NULL;
	if ((C_ARRAY_LENGTH(values_for_notfound) > 1)
	    ? hv_exists_ent(constant_missing, sv, 0) : 0) {
	    sv = newSVpvf("Your vendor has not defined Linux::Fanotify macro %" SVf
			  ", used at %" COP_FILE_F " line %" UVuf "\n", 
			  sv, COP_FILE(cop), (UV)CopLINE(cop));
	} else
#endif
	{
	    sv = newSVpvf("%" SVf
                          " is not a valid Linux::Fanotify macro at %"
			  COP_FILE_F " line %" UVuf "\n",
			  sv, COP_FILE(cop), (UV)CopLINE(cop));
	}
	croak_sv(sv_2mortal(sv));
